﻿using System.Threading;
using JetBrains.Annotations;

namespace Magify
{
    internal class ReusableCancellationTokenSource
    {
        [CanBeNull]
        private CancellationTokenSource _tokenSource = new();

        public CancellationToken GetOrCreate()
        {
            if (_tokenSource == null || _tokenSource.IsCancellationRequested)
            {
                _tokenSource = new CancellationTokenSource();
            }
            return _tokenSource.Token;
        }

        public void CancelCurrent()
        {
            ThreadingUtils.CancelAndRemove(ref _tokenSource);
        }
    }
}